#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
using namespace std;

using ll = long long;
const int INF = (int)2e9;

struct Coord {
	int x, y, z;

	int dist(const Coord& rhs) const {
		return abs(x - rhs.x) + abs(y - rhs.y) + abs(z - rhs.z);
	}
};

vector<bool> vis;
vector<int> ans;
vector<vector<int>> g;
vector<Coord> places;

int dfs(int v) {
	vis[v] = 1;
	int idx = v;
	for (int to = 0; to < g[v].size(); ++to) {
		if (g[v][to] < g[v][idx] && !vis[to])
			idx = to;
	}
	if (idx == v) return 0;
	int res = places[v].dist(places[idx]);
	ans.push_back(idx);
	res += dfs(idx);
	return res;
}

int main() {
	Coord pos;
	cin >> pos.x >> pos.y >> pos.z;
	int n;
	cin >> n;
	vis.resize(n + 1, 0);
	places.resize(n + 1);
	places[0] = pos;
	for (int i = 1; i <= n; ++i)
		cin >> places[i].x >> places[i].y >> places[i].z;
	g.resize(n + 1, vector<int>(n + 1, INF));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j <= n; ++j) {
			g[i][j] = g[j][i] = places[i].dist(places[j]);
		}
	}
	if (n <= 11) {
		vector<int> seq, best;
		int mn = 0;
		for (int i = 1; i <= n; ++i) {
			seq.push_back(i);
			mn += g[i - 1][i];
		}
		best = seq;
		while (next_permutation(seq.begin(), seq.end())) {
			int sum = 0;
			int cur = 0;
			for (int i = 0; i < n; ++i) {
				sum += g[cur][seq[i]];
				cur = seq[i];
				if (sum > mn)
					break;
			}
			if (sum < mn) {
				best = seq;
				mn = sum;
			}
		}
		cout << mn << '\n';
		for (int i = 0; i < n; ++i)
			cout << best[i] << '\n';
		return 0;
	}
	cout << dfs(0) << '\n';
	for (int v : ans)
		cout << v << '\n';
	return 0;
}