#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
using namespace std;

using ll = long long;

struct Change {
	int idx;
	char let;
	int value;

	Change() {}
	Change(int idx, char c, int val) : idx(idx), let(c), value(val) {}

	bool operator<(const Change& rhs) const {
		if (idx != rhs.idx)
			return idx < rhs.idx;
		if (let != rhs.let)
			return let < rhs.let;
		return value < rhs.value;
	}
};

int main() {
	string ind;
	string cmd;
	cin >> ind;
	vector<int> op(101, -1);
	vector<vector<int>> tmp(101, vector<int>(26));
	vector<vector<bool>> changed(101, vector<bool>(26, 0));
	vector<int> v(26, 0);
	vector<int> last(26, -1);
	vector<bool> used(26, 0);
	vector<Change> ans;
	while (ind != ".") {
		int idx = stoi(ind);
		cin >> cmd;
		if (cmd == "BEGIN") {
			tmp[idx] = v;
			fill(changed[idx].begin(), changed[idx].end(), 0);
			int oper;
			cin >> oper;
			op[idx] = oper;
		}
		else if (cmd == "COMMIT") {
			int oper;
			cin >> oper;
			for (int i = 0; i < 26; ++i)
				if (changed[idx][i]) {
					if (last[i] != -1)
						ans.push_back({ last[i], (char)('A' + i), v[i] });
					v[i] = tmp[idx][i];
					last[i] = op[idx];
				}
		}
		else if (cmd == "ROLLBACK") {
			int oper;
			cin >> oper;
			cin >> ind;
			continue;
		}
		else {
			used[cmd[0] - 'A'] = 1;
			if (isalpha(cmd[2])) {
				used[cmd[2] - 'A'] = 1;
				tmp[idx][cmd[0] - 'A'] = tmp[idx][cmd[2] - 'A'] + stoi(cmd.substr(4));
			}
			else {
				tmp[idx][cmd[0] - 'A'] = stoi(cmd.substr(2));
			}
			changed[idx][cmd[0] - 'A'] = 1;
		}
		cin >> ind;
	}
	sort(ans.begin(), ans.end());
	if (!ans.size())
		cout << "NO";
	else {
		for (Change &c : ans)
			cout << c.idx << ' ' << c.let << ' ' << c.value << '\n';
	}
	return 0;
}