#ifdef ON_PC
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

struct file {
    std::string name;
    int start;
};

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    size_t n;
    std::cin >> n;
    std::vector<int> adr(n);
    for (auto &item: adr) {
        std::cin >> item;
    }
    size_t m;
    std::cin >> m;
    std::vector<file> files(m);
    for (size_t i = 0; i < m; ++i) {
        std::string s;
        int start;
        std::cin >> s >> start;
        files[i] = {s, start};
    }

    std::vector<std::string> used(n);
    std::map<std::string, bool> dirty;

    for (const auto &file: files) {
        dirty[file.name] = false;
        used[file.start - 1] = file.name;
        int next = adr[file.start - 1];

        while (next != 0 && next != 1000) {
            if (!used[next - 1].empty()) {
                dirty[file.name] = true;
                dirty[used[next - 1]] = true;
                break;
            }

            used[next - 1] = file.name;
            next = adr[next - 1];
        }

        if (next == 0) {
            dirty[file.name] = true;
        }
    }

    std::vector<std::string> dirty_files;

    for (const auto &item: dirty) {
        if (item.second) {
            dirty_files.emplace_back(item.first);
        }
    }

    std::sort(std::begin(dirty_files), std::end(dirty_files));

    std::cout << dirty_files.size() << "\n";
    for (const auto &item: dirty_files) {
        std::cout << item << "\n";
    }

    std::vector<int> unused;
    for (size_t i = 0; i < n; ++i) {
        if (adr[i] != 0 && used[i].empty()) {
            unused.emplace_back(i + 1);
        }
    }

    std::cout << unused.size() << "\n";
    for (const auto &item: unused) {
        std::cout << item << "\n";
    }

#ifdef ON_PC
    std::cerr << "\n" << static_cast<double>(std::clock()) / CLOCKS_PER_SEC << "\n";
#endif

    return 0;
}

