from sys import stdin
from collections import defaultdict

lines = list(map(lambda x: x.strip(), stdin.readlines()))

raw_commands = []
results = []

stopped = False
for line in lines:
    if line == '.':
        stopped = True
        raw_commands.append(line)
        continue

    if not stopped:
        raw_commands.append(line)
    else:
        results.append(line)

results = results[1:]

commands = []
labels = dict()
cond_jumps = defaultdict(int)

for i, command in enumerate(raw_commands):
    if command == '.':
        commands.append((3,))
        continue

    if command.startswith('JC') or command.startswith('JMP'):
        t, label = command.split(" ")
        commands.append((1 if t == 'JC' else 2, label))
        if t == 'JC':
            cond_jumps[i] = 0
    else:
        labels[command] = i
        commands.append((0,))

cursor = 0


def run():
    global cursor

    if commands[cursor][0] == 0:
        cursor += 1
        # print('NOPE', cursor, commands[cursor])
        return

    if commands[cursor][0] == 2:
        cursor = labels[commands[cursor][1]]
        # print('JUMP', cursor, commands[cursor])
        return


for result in results:
    while commands[cursor][0] != 1 and commands[cursor][0] != 3:
        run()

    if commands[cursor][0] == 3:
        break

    if result == "YES":
        # print('JC SUCC', cursor, commands[cursor], labels[commands[cursor][1]])
        cond_jumps[cursor] += 1
        cursor = labels[commands[cursor][1]]
    else:
        # print('JC FAIL', cursor, commands[cursor], labels[commands[cursor][1]])
        cond_jumps[cursor] -= 1
        cursor += 1

result = []

for item in cond_jumps.items():
    if item[1] < 0:
        result.append(item[0] + 1)

if result:
    print(*result, sep=" ")
else:
    print(0)
