from sys import stdin

lines = list(map(lambda x: x.strip(), stdin.readlines()))

n = int(lines[0])

raw_commands = []
results = []

stopped = False
for line in lines[1:]:
    if line == '.':
        stopped = True
        raw_commands.append(line)
        continue

    if not stopped:
        raw_commands.append(line)
    else:
        results.append(line)

results = results[1:]

commands = []
labels = dict()

for i, command in enumerate(raw_commands):
    if command == '.':
        commands.append((-1, 3))
        continue

    if 'JC' in command or 'JMP' in command:
        mem, t, label = command.split(" ")
        mem = (int(mem) - 1) // n
        commands.append((mem, 1 if t == 'JC' else 2, label))
    else:
        mem, label = command.split(" ")
        mem = (int(mem) - 1) // n
        labels[label] = i
        commands.append((mem, 0))

cursor = 0
cache = (0, -1)
cache_misses = 1
cache_freeze = 0


def run():
    global cursor, cache, cache_misses

    if commands[cursor][1] == 0:
        cursor += 1

        if commands[cursor][1] == 3:
            return

        if commands[cursor][0] != cache[0]:
            if commands[cursor][0] not in cache:
                cache_misses += 1
            cache = (commands[cursor][0], cache[0])

        return

    if commands[cursor][1] == 2:
        cursor = labels[commands[cursor][2]]

        if commands[cursor][0] != cache[0]:
            if commands[cursor][0] not in cache:
                cache_misses += 1
            cache = (commands[cursor][0], cache[0])


for result in results:
    while commands[cursor][1] != 1 and commands[cursor][1] != 3:
        run()

    if commands[cursor][1] == 3:
        break

    if result == "YES":
        cursor = labels[commands[cursor][2]]

        if commands[cursor][0] != cache[0]:
            if commands[cursor][0] not in cache:
                cache_misses += 1
                if cache[1] != -1:
                    cache_freeze += 1
            cache = (commands[cursor][0], cache[0])

    else:
        cursor += 1

        if commands[cursor][1] == 3:
            break

        if commands[cursor][0] != cache[0]:
            if commands[cursor][0] not in cache:
                cache_misses += 1
            cache = (commands[cursor][0], cache[0])

print(cache_misses, cache_freeze)
