class Process:
    def __init__(self,res):
        self.resources = res.copy()
        self.changes = []

    def change(self,command):
        toChange = command[0]
        if(command[2] in "0123456789"):
            self.resources[toChange] = int(command[2:])
        else:
            additive = command[2]
            self.resources[toChange] = self.resources.get(additive,0)+int(command[4:])
        if(toChange not in self.changes): self.changes.append(toChange)

    def commit(self):
        res = {}
        for changed in self.changes:
            res[changed] = self.resources[changed]
        return res

resources = {}
processes = {}
inp = ""
while inp!=".":
    inp = input()
    if inp=="": continue
    if inp==".": break
    id, command = inp.split()
    if(command=="BEGIN"):
        processes[id] = Process(resources)
    elif(command=="COMMIT"):
        commt = processes.pop(id).commit()
        for S in commt.keys():
            resources[S] = commt[S]
    elif (command == "ROLLBACK"):
        processes.pop(id)
    else:
        if(resources.get(command[0],-1)==-1): resources[command[0]]=0
        if(command[2] not in "0123456789"):
            if (resources.get(command[2], -1) == -1): resources[command[2]] = 0
        processes[id].change(command)
keys = list(sorted(list(resources.keys())))
for K in keys:
    print(K+"="+str(resources[K]))