class Student:
    def __init__(self, _id, class_id, surname, name):
        self.id = int(_id)
        self.class_id = int(class_id)
        self.surname = surname
        self.name = name

    def get_info(self):
        return f"{self.id} {self.surname} {self.name}"
        
class Class:
    def __init__(self, _id, school_id, name):
        self.id = int(_id)
        self.sid = int(school_id)
        self.name = name
        self.students = []

    def get_info(self):
        if len(self.students) > 0:
            s_info = [f"{self.id} {self.name} " + s.get_info() for s in self.students]
            
            return s_info
        return [f"{self.id} {self.name}"]

class School:
    def __init__(self, _id, name):
        self.id = int(_id)
        self.name = name
        self.classes = []

    def get_info(self):
        if len(self.classes) > 0:
            s_info = []
            for c in self.classes:
                s_info.extend([f"{self.id} {self.name} "  + i for i in c.get_info()])
            s_info = "\n".join(s_info)
            return s_info
        return f"{self.id} {self.name}"

    def print_info(self):
        print(self.get_info())
        


schools = dict()
for i in range(int(input())):
    d = input().split()
    schools[int(d[0])] = School(*d)
classes = dict()
for i in range(int(input())):
    d = input().split()
    classes[int(d[0])] = Class(*d)
studs = []
for i in range(int(input())):
    studs.append(Student(*input().split()))
for s in studs:
    classes[s.class_id].students.append(s)
for c in classes:
    classes[c].students.sort(key=lambda x: x.id)
    schools[classes[c].sid].classes.append(classes[c])
for s in sorted(schools):
    schools[s].classes.sort(key=lambda x: x.id)
    schools[s].print_info()
'''
2
1 School1
2 School2
4
1 1 11a
2 1 11b
3 2 11a
4 2 11b
7
1 1 Ivanov Ivan
2 1 Petrov Petr
3 2 Aleshin Aleksey
4 2 Vasiliev Vasiliy
5 3 Semenov Semen
6 3 Ivanov Petr
7 3 Petrov Semen   
'''
'''
2
1 School1
2 School2
2
2 2 11b
1 2 11a
4
4 2 Vasiliev Vasiliy
1 1 Ivanov Ivan
3 2 Aleshin Aleksey
2 1 Petrov Petr
'''


