class Process:
    def __init__(self, name):
        self.name = name
        self.locked_res = []
        self.status = "ready"
        self.w_res = None

class Resource:
    def __init__(self, name):
        self.name = name
        self.status = "unlocked"
        self.process = None


def check_deadlock(processes, resources):
    #print([p.status for p in processes.values()])
    wp = [p for p in processes.values() if p.status == 'wait']
    #print(*[p.name for p in wp])
    rlocked = []
    rwait = []
    for p in wp:
        rlocked.extend(p.locked_res)
        rwait.append(p.w_res)
    #print(rwait)
    #print(rlocked)
    if set(rwait).issubset(set(rlocked)) and len(wp) != 0:
        i = 0
        while i < len(wp):
            new_wp = wp.copy()
            del new_wp[i]
            n_rlocked = []
            n_rwait = []
            for p in new_wp:
                n_rlocked.extend(p.locked_res)
                n_rwait.append(p.w_res)
            if set(n_rwait).issubset(set(n_rlocked)) and len(new_wp) != 0:
                wp = new_wp
            else:
                i += 1
        return (True, sorted([int(p.name) for p in wp]))
    return (False, 0)



processes = dict()
resources = dict()
comm = input()
while comm != ".":
    proc, res, com = comm.split()
    #print([r.status for r in resources.values()])
    if proc not in processes:
        processes[proc] = Process(proc)
    if res not in resources:
        resources[res] = Resource(res)
    #print([r.status for r in resources.values()])
    if com == "L":
        if resources[res].status == "unlocked":
            #print(resources[res].status)
            resources[res].status = "locked"
            resources[res].process = proc
            processes[proc].locked_res.append(res)
            #print([r.status for r in resources.values()])
        else:
            processes[proc].status = "wait"
            processes[proc].w_res = res
            #print([r.status for r in processes.values()])
        ch = check_deadlock(processes, resources)
        if ch[0]:
            print('DEADLOCK')
            print(*ch[1])
            break
    else:
        processes[proc].locked_res.remove(res)
        resources[res].status = "unlocked"
        resources[res].process = None
        while True:
            for p in processes.values():
                if p.status == "wait":
                    if resources[p.w_res].status == "unlocked":
                        resources[p.w_res].status = "locked"
                        resources[p.w_res].process = proc
                        p.status = "ready"
                        p.locked_res.append(res)
                        p.w_res = None
                        break
            else:
                break
    comm = input()
    
            
        


else:
    print("NO DEADLOCK")
    print(sum([1 if resources[i].status == "locked" else 0 for i in resources]))



'''
1 A L
2 B L
1 A U
2 B U
.
'''

'''
1 A L
2 B L
3 Z L
2 Z L
3 A L
1 Z L
.
'''
