class Process:
    def __init__(self, name):
        self.name = name
        self.locked_res = []
        self.status = "ready"
        self.w_res = None
        self.w_res_block_t = None

class Resource:
    def __init__(self, name):
        self.name = name
        self.status = "unlocked"
        self.process = []
        self.rblock_res = []


def check_deadlock(processes, resources):
    #print([p.status for p in processes.values()])
    wp = [p for p in processes.values() if p.status == 'wait']
    #print(*[p.name for p in wp])
    rlocked = []
    rwait = []
    for p in wp:
        rlocked.extend(p.locked_res)
        rwait.append(p.w_res)
    #print(rwait)
    #print(rlocked)
    if set(rwait).issubset(set(rlocked)) and len(wp) != 0:
        i = 0
        while i < len(wp):
            new_wp = wp.copy()
            del new_wp[i]
            n_rlocked = []
            n_rwait = []
            for p in new_wp:
                n_rlocked.extend(p.locked_res)
                n_rwait.append(p.w_res)
            if set(n_rwait).issubset(set(n_rlocked)) and len(new_wp) != 0:
                wp = new_wp
            else:
                i += 1
        return (True, sorted([int(p.name) for p in wp]))
    return (False, 0)



processes = dict()
resources = dict()
comm = input()
while comm != ".":
    proc, res, com = comm.split()
    #print([r.status for r in resources.values()])
    if proc not in processes:
        processes[proc] = Process(proc)
    if res not in resources:
        resources[res] = Resource(res)
    #print([r.status for r in resources.values()])
    if com == "R":
        if resources[res].status in ["unlocked", "rlocked"]:
            #print(resources[res].status)
            resources[res].status = "rlocked"
            resources[res].process.append(proc)
            processes[proc].locked_res.append(res)
            #print([r.status for r in resources.values()])
        else:
            processes[proc].status = "wait"
            processes[proc].w_res = res
            processes[proc].w_res_block_t = "r"
            #print([r.status for r in processes.values()])
        ch = check_deadlock(processes, resources)
        if ch[0]:
            print('DEADLOCK')
            print(*ch[1])
            break
    elif com == "W":
        if resources[res].status == "unlocked":
            #print(resources[res].status)
            resources[res].status = "wlocked"
            resources[res].process.append(proc)
            processes[proc].locked_res.append(res)
            #print([r.status for r in resources.values()])
        else:
            processes[proc].status = "wait"
            processes[proc].w_res = res
            processes[proc].w_res_block_t = "w"
            #print([r.status for r in processes.values()])
        ch = check_deadlock(processes, resources)
        if ch[0]:
            print('DEADLOCK')
            print(*ch[1])
            break
    else:
        processes[proc].locked_res.remove(res)
        if resources[res].status == "rblocked":
            resources[res].process.remove(proc)
            if len(resources[res].process) == 0:
                resources[res].status = "unlocked"
        else:
            resources[res].status = "unlocked"
            resources[res].process.remove(proc)
        while True:
            for p in processes.values():
                if p.status == "wait":
                    if p.w_res_block_t == "r" and resources[p.w_res].status in ["rblocked", "unlocked"]:
                        resources[p.w_res].status = "rlocked"
                        resources[p.w_res].process.append(proc)
                        p.status = "ready"
                        p.locked_res.append(res)
                        break
                    elif p.w_res_block_t == "w" and resources[p.w_res].status == "unblocked":
                        resources[p.w_res].status = "wlocked"
                        resources[p.w_res].process.append(proc)
                        p.status = "ready"
                        p.locked_res.append(res)
                        break
            else:
                break
    comm = input()
    
            
        


else:
    print("NO DEADLOCK")
    print(sum([1 if resources[i].status == "locked" else 0 for i in resources]))



'''
1 A W
2 B W
1 A U
2 B U
.
'''

'''
1 A R
2 B W
3 Z R
2 Z W
3 A W
1 Z W
.
'''
