#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
typedef long long ll;
typedef double db;

const int INF = 1e9;

using namespace std;

struct pnt{
    ll x,y;
};

bool cmp( pnt a, pnt b ){
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main()
{
    ll n, m, k;
    cin >> n >> m >> k;

    vector<pnt> a(k);
    for( int i = 0; i < k; ++i ){
        ll x, y, s;
        cin >> x >> y >> s;
        a[i] = {x, y};
    }

    a.push_back({0, 0});
    a.push_back({n+1, 0});

    sort( a.begin(), a.end(), cmp );

    ll ans = 0;
    pnt id_leftup, id_rightdown;

    for( int i = 0; i < a.size(); ++i ){
        multiset<ll> ys;
        ys.insert(0);
        ys.insert(m+1);

        for( int j = i+1; j < a.size(); ++j ){
            ll lenx = a[j].x - a[i].x - 1;
            multiset<ll>::iterator it = ys.upper_bound(a[j].y);

            ll up_y = *it;
            it--;
            ll down_y = *it;

            ll leny = up_y - down_y - 1;
            ll sum = lenx * leny;

            /*
            cout << up_y << ' ' << down_y << " yss\n";
            cout << lenx << ' ' << leny << ' ' << i << ' ' << j << '\n';
            */

            if( sum > ans ){
                ans = sum;
                id_leftup = {a[i].x + 1, down_y + 1};
                id_rightdown = {a[j].x - 1, up_y - 1};
            }

            ys.insert(a[j].y);
        }
    }

    //cout << ans << '\n';
    cout << id_leftup.x << ' ' << id_leftup.y << '\n';
    cout << id_rightdown.x << ' ' << id_rightdown.y << '\n';

    return 0;
}

/*
100 100 2
1 1 5
100 90 5

1000 1000 3
1 1 1
1 2 2
1 3 3
*/
