#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
#include <ctime>
using namespace std;
typedef long long ll;
typedef double db;

const int INF = 1e9;

int string_to_ll( const string &s ){
    int a = 0, p = 1, len = s.size();
    for( int i = (int)s.size() - 1; i >= 0; --i ){
        a += (s[i] - '0') * p;
        p *= 10;
    }

    return a;
}

vector<vector<int> > res(26, vector<int>());
vector<vector<int> > gr(100, vector<int>(100));

stack<int> way;
vector<bool> used(100, false);

vector<int> ans;

void cycle( int v, int last ){
    used[v] = true;
    way.push(v);

    for( int to = 0; to < 100; ++to ){
        if( gr[v][to] > 0 ){
            if( !used[to] ) cycle( to, v );
            else if( ans.empty() ){
                while( way.top() != to ){
                    ans.push_back(way.top());
                    way.pop();
                }
                ans.push_back(way.top());

                sort( ans.begin(), ans.end() );
            }
        }
    }

    way.pop();
    used[v] = false;
}

/*
void print_table( int n ){
    for( int i = 0; i < n; ++i ){
        for( int j = 0; j < n; ++j ){
            cout << gr[i][j] << ' ';
        }
        cout << '\n';
    }
}
 */

int main()
{
    string s;
    while( cin >> s && s != "." ){
        int p = string_to_ll(s);
        p--;

        char r, req;
        cin >> r >> req;
        int let = r - 'A';

        if( ans.empty() ){
            if( req == 'L' ){
                if( !res[let].empty() ){
                    int v = *res[let].begin();
                    gr[p][v]++;

                    fill( used.begin(), used.end(), false );
                    cycle(v, -1);
                }
                res[let].push_back(p);

            } else{
                res[let].erase(res[let].begin());

                for( int i = 0; i < res[let].size(); ++i ){
                    int v = res[let][i];
                    gr[v][p]--;
                }
            }
        }
    }

    if( !ans.empty() ){
            cout << "DEADLOCK\n";
            for( int i = 0; i < ans.size(); ++i ){
                cout << ans[i] + 1 << ' ';
            }
    } else{
        cout << "NO DEADLOCK\n";
        int anss = 0;
        for( int i = 0; i < 26; ++i ){
            if( !res[i].empty() ) anss++;
        }
        cout << anss << '\n';
    }

    return 0;
}

/*
1 A L
2 B L
1 A U
2 B U
.

1 A L
2 B L
3 Z L
2 Z L
3 A L
1 Z L
.

1 A L
2 B L
3 Z L
1 Z L
3 B L
2 A L
.
*/
