#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <set>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
#include <ctime>
using namespace std;
typedef long long ll;
typedef double db;

const int INF = 1e9;

int string_to_ll( const string &s ){
    int a = 0, p = 1, len = s.size();
    for( int i = (int)s.size() - 1; i >= 0; --i ){
        a += (s[i] - '0') * p;
        p *= 10;
    }

    return a;
}

struct res{
    set<int> read;
    vector<pair<int, int> > que = {};
};

vector<res> pnt(26);
vector<vector<int> > gr(100, vector<int>(100));

stack<int> way;
vector<bool> used(100, false);

vector<int> ans;

void cycle( int v, int last ){
    used[v] = true;
    way.push(v);

    for( int to = 0; to < 100; ++to ){
        if( gr[v][to] > 0 ){
            if( !used[to] ) cycle( to, v );
            else if( ans.empty() ){
                while( way.top() != to ){
                    ans.push_back(way.top());
                    way.pop();
                }
                ans.push_back(way.top());

                sort( ans.begin(), ans.end() );
            }
        }
    }

    way.pop();
    used[v] = false;
}

/*
void print_table( int n ){
    for( int i = 0; i < n; ++i ){
        for( int j = 0; j < n; ++j ){
            cout << gr[i][j] << ' ';
        }
        cout << '\n';
    }
}
 */

int main()
{
    string s;
    while( cin >> s && s != "." ){
        int p = string_to_ll(s);
        p--;

        char r, req;
        cin >> r >> req;
        int let = r - 'A';

        if( ans.empty() ){
            if( req == 'R' ){

               if( pnt[let].que.empty() ){
                    pnt[let].read.insert(p);
               } else{
                    int v = pnt[let].que.begin()->first;
                    gr[p][v]++;

                    fill( used.begin(), used.end(), false );
                    cycle(p, -1);

                    pnt[let].que.push_back({p, 2});
               }

            } else if( req == 'W' ){

                if( !pnt[let].read.empty() ){
                    for( set<int>::iterator it = pnt[let].read.begin(); it != pnt[let].read.end(); ++it ){
                        int v = *it;
                        gr[p][v]++;
                    }
                } else{
                    if( !pnt[let].que.empty() ){
                        int v = pnt[let].que.begin()->first;
                        gr[p][v]++;
                    }
                    pnt[let].que.push_back({p, 1});
                }

                fill( used.begin(), used.end(), false );
                cycle(p, -1);
            } else{
                if( pnt[let].read.find(p) != pnt[let].read.end() ){
                    pnt[let].read.erase(p);

                    for( int i = 0; i < pnt[let].que.size(); ++i ){
                        int v = pnt[let].que[i].first;
                        gr[v][p]--;
                    }
                } else{
                    pnt[let].que.erase(pnt[let].que.begin());

                    for( int i = 0; i < pnt[let].que.size(); ++i ){
                        int v = pnt[let].que[i].first;
                        gr[v][p]--;
                    }

                    while( !pnt[let].que.empty() && pnt[let].que.begin()->second == 2 ){
                        int v = pnt[let].que.begin()->first;
                        pnt[let].read.insert(v);
                        pnt[let].que.erase(pnt[let].que.begin());

                        for( int i = 0; i < pnt[let].que.size(); ++i ){
                             int u = pnt[let].que.begin()->first;
                            gr[v][u]++;
                        }
                    }
                }
            }
        }
    }

    if( !ans.empty() ){
            cout << "DEADLOCK\n";
            for( int i = 0; i < ans.size(); ++i ){
                cout << ans[i] + 1 << ' ';
            }
    } else{
        cout << "NO DEADLOCK\n";
        int anss = 0;
        for( int i = 0; i < 26; ++i ){
            if( !pnt[i].que.empty() || !pnt[i].read.empty() ) anss++;
        }
        cout << anss << '\n';
    }

    return 0;
}

/*

1 A W
2 B W
1 A U
2 B U
.

*/
