#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct connection {
    int id_school, id_class, id_schoolar;
    string name_school, name_class, name_schoolar;

    connection(int _id_s, string _n_s, int _id_c, string _n_c, int _id_schoolar, string _n_schoolar) {
        id_school = _id_s;
        id_class = _id_c;
        id_schoolar = _id_schoolar;

        name_school = _n_s;
        name_class = _n_c;
        name_schoolar = _n_schoolar;
    }

    bool friend operator< (connection L, connection R) {
        if (L.id_school == R.id_school) {
            if (L.id_class == R.id_class) {
                return L.id_schoolar < R.id_schoolar;
            }
            return L.id_class < R.id_class;
        }
        return L.id_school < R.id_school;
    }
};

int main() {
    map<int, string> schools;
    vector<int> s_c(200004);
    map<int, pair<int, string> > classes;
    vector<int> c_s(200004);
    map<int, pair<int, string> > schoolars;

    int s, c, p;

    cin >> s;
    for (int i = 0; i < s; ++i) {
        int id;
        string name;
        cin >> id >> name;

        schools[id] = name;
    }

    cin >> c;
    for (int i = 0; i < c; ++i) {
        int id, id_school;
        string name;
        cin >> id >> id_school >> name;

        classes[id] = make_pair(id_school, name);
        ++s_c[id_school];
    }

    cin >> p;
    vector<int> schoolars_ids;
    for (int i = 0; i < p; ++i) {
        int id, id_class;
        string surname, firstname;
        cin >> id >> id_class >> surname >> firstname;

        schoolars[id] = make_pair(id_class, surname + " " + firstname);
        schoolars_ids.push_back(id);
        ++c_s[id_class];
    }

    set<connection> ans;
    for (auto& id: schoolars_ids) {
        pair<int, string> cur = schoolars[id];
        string p_n = cur.second;
        int id_c = cur.first;

        pair<int, string> cur_class = classes[id_c];
        string c_name = cur_class.second;
        int id_s = cur_class.first;

        string s_name = schools[id_s];
        ans.emplace(id_s, s_name, id_c, c_name, id, p_n);
    }

    for (int i = 0; i < 200004; ++i) {
        if (!c_s[i] && classes.count(i)) {
            pair<int, string> cur_class = classes[i];
            string c_name = cur_class.second;
            int id_s = cur_class.first;

            string s_name = schools[id_s];

            ans.emplace(id_s, s_name, i, c_name, -1, "");
        }
        if (!s_c[i] && schools.count(i)) {
            string s_name = schools[i];

            ans.emplace(i, s_name, -1, "", -1, "");
        }
    }

    for (auto& connect: ans) {
        if (connect.id_schoolar > 0) {
            cout << connect.id_school << " " << connect.name_school << " " << connect.id_class << " " << connect.name_class << " " << connect.id_schoolar << " " << connect.name_schoolar << endl;
        }
        else if (connect.id_class > 0) {
            cout << connect.id_school << " " << connect.name_school << " " << connect.id_class << " " << connect.name_class << endl;
        }
        else {
            cout << connect.id_school << " " << connect.name_school << endl;
        }
    }

    return 0;
}
