#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<vector<pair<int, int>>> locks(30);
vector<queue<pair<int, int>>> block_queue(30);
vector<set<int>> block_set(30);
vector<set<int>> graph(104);
vector<int> current;

int flag;
void dfs(int v, vector<int>& color, vector<int> _current, int cc) {
    _current.push_back(v);
    if (color[v] > -1) {
        if (color[v] == cc) {
            flag = 1;
            current = _current;
        }
        return;
    }

    color[v] = cc;

    for (auto& u: graph[v]) {
        dfs(u, color, _current, cc);
    }
}

int main() {
    string inpt;
    vector<int> arr;
    set<int> ans;
    int _flag = 1;
    while (1) {
        getline(cin, inpt);
        if (inpt[0] =='.') break;

        int id = 0;
        int name;
        char type;
        int pos = 0;
        for (int i = 0; i < inpt.size() && inpt[i] - '0' < 10 && inpt[i] - '0' > -1; ++i) {
            id = id * 10 + inpt[i] - '0';
            pos = i;
        }
        --id;
        name = inpt[pos + 2] - 'A';
        type = inpt[pos + 4];

        if (type == 'R') {
            if (locks[name].size() == 0 || locks[name][0].second == 1) {
                locks[name].push_back(make_pair(id, 1));
            }
            else {
                for (auto& i: locks[name]) {
                    graph[id].insert(i.first);
                }
                block_queue[name].push(make_pair(id, 1));
                block_set[name].insert(id);
            }
        }
        else if (type == 'W') {
            if (locks[name].size() == 0) {
                locks[name].push_back(make_pair(id, 0));
            }
            else {
                for (auto& i: locks[name]) {
                    graph[id].insert(i.first);
                }
                block_queue[name].push(make_pair(id, 0));
                block_set[name].insert(id);
            }
        }
        else {
            vector<pair<int, int>> before = locks[name];
            locks[name].clear();
            for(auto& i: before) {
                if (i.first != id) {
                    locks[name].push_back(i);
                }
            }

            for (int i = 0; i < 104; ++i) {
                if (graph[i].count(id)) {
                    graph[i].erase(id);
                }
            }

            pair<int, int> next;
            if (!block_queue[name].empty()) {
                next = block_queue[name].front();
                if (next.second == 1 || next.second == 0 && locks[name].size() == 0) {
                    graph[next.first].clear();
                    block_queue[name].pop();
                    block_set[name].erase(next.first);

                    locks[name].push_back(next);
                    for (auto& i: block_set[name]) {
                        graph[i].erase(id);
                        graph[i].insert(next.first);
                    }
                }

            }
        }

        /*
        for (int i = 0; i < 4; ++i) {
            for (auto& u: graph[i]) {
                cout << u << " ";
            }
            cout << endl;
        }

        for (int i = 0; i < 4; ++i) {
            for (auto& u: locks[i]) {
                cout << u.first << " ";
            }
            cout << endl;
        }
        */

        if (_flag) {
            flag = 0;
            vector<int> color(104, -1);
            for (int i = 0; i < 104; ++i) {
                if (color[i] == -1) {
                    dfs(i, color, {}, i);
                    if (flag) {
                        _flag = 0;
                        for (auto& i: current) ans.insert(i);
                        break;
                    }
                }
            }
        }
        //cout << _flag << endl;
    }
    if (_flag) {
        int counter = 0;
        for (int i = 0; i < 30; ++i) if (locks[i].size()) ++counter;
        cout << "NO DEADLOCK" << endl << counter;
    }
    else {
        cout << "DEADLOCK" << endl;
        for (auto& i: ans) cout << i + 1 << " ";
    }

    return 0;
}
