from collections import defaultdict

res_status = defaultdict(lambda: ['U', -1])
res_waiters = defaultdict(list)
pblocker = defaultdict(lambda: '')
powne = defaultdict(set)


def check(pid, start_blockers=None):
    global res_status, res_waiters

    if pblocker[pid] == '':
        return []

    if start_blockers is not None and pblocker[pid] in start_blockers:
        return [pid]

    if start_blockers is None:
        start_blockers = powne[pid]

    blocker_owner = res_status[pblocker[pid]][1]

    result = check(blocker_owner, start_blockers)

    if len(result) == 0:
        return []
    else:
        return [pid] + result


def lock(pid, rid):
    global res_status, res_waiters

    if res_status[rid][0] == "U":
        res_status[rid] = ["L", pid]
        powne[pid].add(rid)
    else:
        res_waiters[rid].append(pid)
        pblocker[pid] = rid


def unlock(rid):
    global res_status, res_waiters

    powne[res_status[rid][1]].remove(rid)

    if len(res_waiters[rid]) > 0:
        res_status[rid] = ["L", res_waiters[rid][0]]
        pblocker[res_waiters[rid][0]] = ''
        powne[res_waiters[rid][0]].add(rid)
        res_waiters[rid] = res_waiters[rid][1:]
    else:
        res_status[rid] = ["U", -1]


while True:
    s = input()

    if s == ".":
        blocked_r = 0

        for ri in res_status.items():
            if ri[1][0] == 'L':
                blocked_r += 1

        print("NO DEADLOCK", blocked_r, sep="\n")
        break

    pid, rid, de = s.split()

    if de == "L":
        lock(pid, rid)
    else:
        unlock(rid)

    result = check(pid)
    if len(result) > 0:
        print("DEADLOCK", " ".join(sorted(result)), sep="\n")
        break
