from collections import defaultdict

res_status = defaultdict(lambda: ['U', set()])
res_waiters = defaultdict(list)
pblocker = defaultdict(lambda: '')
powne = defaultdict(set)


def check(pid, start_blockers=None):
    global res_status, res_waiters

    if pblocker[pid] == '':
        return []

    if start_blockers is not None and pblocker[pid] in start_blockers:
        return [pid]

    if start_blockers is None:
        start_blockers = powne[pid]

    blocker_owners = res_status[pblocker[pid]][1]

    for blocker_owner in blocker_owners:
        result = check(blocker_owner, start_blockers)

        if len(result) > 0:
            return [pid] + result

    return []


def lock_r(pid, rid):
    global res_status, res_waiters

    if res_status[rid][0] == "U":
        res_status[rid] = ["R", set([pid])]
        powne[pid].add(rid)
    elif res_status[rid][0] == "R":
        res_status[rid][1].add(pid)
        powne[pid].add(rid)
    else:
        res_waiters[rid].append(["R", pid])
        pblocker[pid] = rid


def lock_w(pid, rid):
    global res_status, res_waiters

    if res_status[rid][0] == "U":
        res_status[rid] = ["W", set([pid])]
        powne[pid].add(rid)
    else:
        res_waiters[rid].append(["W", pid])
        pblocker[pid] = rid


def unlock(pid, rid):
    global res_status, res_waiters

    res_status[rid][1].remove(pid)
    powne[pid].remove(rid)

    if len(res_status[rid][1]) > 0:
        return

    if len(res_waiters[rid]) > 0 and res_waiters[rid][0][0] == 'R':
        res_status[rid] = ["R", set([res_waiters[rid][0][1]])]
        pblocker[res_waiters[rid][0][1]] = ''
        powne[res_waiters[rid][0][1]].add(rid)
        res_waiters[rid] = res_waiters[rid][1:]
    elif len(res_waiters[rid]) > 0 and res_waiters[rid][0][0] == 'W':
        res_status[rid] = ["W", set([res_waiters[rid][0][1]])]
        pblocker[res_waiters[rid][0][1]] = ''
        powne[res_waiters[rid][0][1]].add(rid)
        res_waiters[rid] = res_waiters[rid][1:]
    else:
        res_status[rid] = ["U", set()]


while True:
    s = input()

    if s == ".":
        blocked_r = 0

        for ri in res_status.items():
            if ri[1][0] != 'U':
                blocked_r += 1

        print("NO DEADLOCK", blocked_r, sep="\n")
        break

    pid, rid, de = s.split()

    if de == "R":
        lock_r(pid, rid)
    elif de == "W":
        lock_w(pid, rid)
    else:
        unlock(pid, rid)

    result = check(pid)
    if len(result) > 0:
        print("DEADLOCK", " ".join(sorted(result)), sep="\n")
        break
