from sys import stdin, stdout

alf = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
l = len(alf)

processes = {}
processes[0] = [None]*l # db
to_show = set()


def interp(proc_n, command):
    if command == 'BEGIN':
        processes[proc_n] = processes[0].copy()

    elif command == 'COMMIT':
        cur_proc = processes[proc_n]
        
        for i in range(l):
            if cur_proc[i] is None: continue            
            processes[0][i] = cur_proc[i]

        del processes[proc_n]

    elif command == 'ROLLBACK':
        del processes[proc_n]

    else:
        cur_proc = processes[proc_n]
        key, val = command.split('=')
        key = alf.index(key)
        to_show.add(key)
        res = None
        if '+' in val:
            from_key, add_v = val.split('+')
            from_key = alf.index(from_key)
            if cur_proc[from_key] is not None:
                res = cur_proc[from_key] + int(add_v)
            else:
                res = int(add_v)
        else:
            res = int(val)

        processes[proc_n][key] = res


def solve():
    t = stdin.readline().strip('\n')

    while t != '.':
        proc_n, command = t.split()
        interp(int(proc_n), command)
        t = stdin.readline().strip('\n')

    for i in to_show:
        if processes[0][i] is not None:
            stdout.write(f'{alf[i]}={processes[0][i]}\n')
        else:
            stdout.write(f'{alf[i]}=0\n')


if __name__ == "__main__":
    solve()
