from sys import stdin, stdout

alf = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
l = len(alf)

processes = {}
processes[0] = [(None, 0)]*l # db
proc_trans = [0]*100
to_show = set()

missed_vals = []

def interp(proc_n, command, trans_n=None):
    if command == 'BEGIN':
        proc_trans[proc_n] = trans_n
        processes[proc_n] = [None]*l
        for i in range(l):
            processes[proc_n][i] = processes[0][i][0]
            processes[0][i] = (processes[0][i][0], 0)

    elif command == 'COMMIT':
        cur_proc = processes[proc_n]
        
        for i in range(l):
            if cur_proc[i] is None: continue
            if processes[0][i][1] != 0:
                missed_vals.append((processes[0][i][1], alf[i], processes[0][i][0]))
            processes[0][i] = (cur_proc[i], trans_n)

        del processes[proc_n]

    elif command == 'ROLLBACK':
        proc_trans[proc_n] = 0
        del processes[proc_n]

    else:
        cur_proc = processes[proc_n]
        key, val = command.split('=')
        key = alf.index(key)
        to_show.add(key)
        res = None
        if '+' in val:
            from_key, add_v = val.split('+')
            from_key = alf.index(from_key)
            if cur_proc[from_key] is not None:
                res = cur_proc[from_key] + int(add_v)
            else:
                res = int(add_v)
        else:
            res = int(val)

        processes[proc_n][key] = res


def solve(): 
    t = stdin.readline().strip('\n')
    
    while t != '.':
        if '=' not in t:
            proc_n, command, tr_n = t.split()
            interp(int(proc_n), command, trans_n=int(tr_n))
        else:
            proc_n, command = t.split()
            interp(int(proc_n), command)

        t = stdin.readline().strip('\n')
    
    if not missed_vals:
        stdout.write('NO')
        return
    
    for i in missed_vals:
        stdout.write(f'{i[0]} {i[1]} {i[2]}\n')

if __name__ == "__main__":
    solve()
