#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <cctype>
#include <algorithm>
using namespace std;

#define SZ(sp) int(sp.size())
#define all(sp) sp.begin(), sp.end()

struct coord {
    int x, y, z, num;

    void input(int nnum=0) {
        cin >> x >> y >> z;
        num = nnum;
    }

    int dist(coord a) {
        return abs(x - a.x) + abs(y - a.y) + abs(z - a.z);
    }
};

char in(int mask, int i) {
    return ((mask >> i) & 1);
}

int main() {
    coord start;
    start.input();
    int sz;
    cin >> sz;
    vector < coord > arr(sz);
    for (int i = 0; i < sz; ++i) {
        arr[i].input(i + 1);
    }
    int n = (1 << sz);
    vector < vector < int > > dp(n, vector < int > (sz, 1e9));
    vector < vector < int > > pred(n, vector < int > (sz, -1));
    for (int i = 0; i < sz; ++i) {
        dp[1 << i][i] = start.dist(arr[i]);
    }
    for (int mask = 0; mask < n - 1; ++mask) {
        for (int i = 0; i < sz; ++i) {
            if (!in(mask, i) || dp[mask][i] == 1e9) {
                continue;
            }
            for (int j = 0; j < sz; ++j) {
                if (in(mask, j)) {
                    continue;
                }
                int nmask = (mask | (1 << j));
                if (dp[nmask][j] > dp[mask][i] + arr[i].dist(arr[j])) {
                    dp[nmask][j] = dp[mask][i] + arr[i].dist(arr[j]);
                    pred[nmask][j] = i;
                }
            }
        }
    }
    int mask = n - 1;
    int cur = 0;
    for (int i = 0; i < sz; ++i) {
        if (dp[mask][cur] > dp[mask][i]) {
            cur = i;
        }
    }
    cout << dp[mask][cur] << '\n';
    vector < int > ans;
    while (cur != -1) {
        ans.emplace_back(cur);
        int ncur = pred[mask][cur];
        mask -= (1 << cur);
        cur = ncur;
    }
    reverse(all(ans));
    for (auto &el : ans) {
        cout << el + 1 << '\n';
    }
}