# DNCFTB

'''
Тесты:

1 BEGIN 5
1 A=5
2 BEGIN 7
1 B=1
2 B=A+10
1 COMMIT 5
2 COMMIT 7
.

5 B 1

---

1 BEGIN 1
2 BEGIN 2
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN 3
3 C=5
1 COMMIT 1
3 B=A+10
2 COMMIT 2
3 A=B+20
3 ROLLBACK 3
.

1 A 1
1 B 4

---
Первый тест показывает, что вывести надо те ресурсы, которые ИЗМЕНЯЛИСЬ параллельно еще где-то
Так, при "открытой" транзакции №5, в транзакции №7 был изменен ресурс В, который ранее был изменен,
но не сохранен в транзакции №5. Следовательно, вывод 5 В 1

Второй тест показывает, что вывести надо те ресурсы, которые ЗАПРАШИВАЛИСЬ для изменения других ресурсов
параллельно еще где-то.
Так, при открытой транзакции №1, ресурс А=1 запрашивался в транзакции №2 для изменения ресурса В (1 А 1)
при открытой транзакции №1, ресурс В=4 запрашивался в транзакции №2 для изменения ресурса А (1 В 4)

Эти два теста противоречат друг другу. В условии написано, по сути, что верны рассуждения в тесте №2
(Выходные данные: номера транзакций, чьи зафиксированные изменения ресурсов не были учтены (были утрачены)
в параллельно выполнявшихся транзакциях)

При рассуждениях из первого теста, выходные данные во втором тесте должны быть:
1 А 1
2 В 2

При рассуждениях из второго теста, выходные данные в первом тесте должны быть:
5 А 5

Я выбрал рассуждения второго теста.
'''

def conc(d1, d2, u2):
    for k in d2.keys():
        if u2[ord(k) - ord('A')]:
            d1[k] = d2[k]
    return d1

tr = {}
tr_u = {}
db = {}
used = [False for k in range(26)]
numtrs = {}
usedtrs = []
comms = []
res = []

for k in range(26):
    db[chr(ord('A') + k)] = 0

while True:
    inp = input()
    if inp == '.':
        break
    if inp == '' or inp == ' ':
        continue

    n, act = inp.split(maxsplit=1)
    n = int(n)

    if " " in act:
        act, m = act.split()
        m = int(m)


    if act == "BEGIN":
        tr[n] = db.copy()
        tr_u[n] = [False for k in range(26)]
        numtrs[n] = m
        comms.append([numtrs[n], "b"])

    elif act == "COMMIT":
        db = conc(db, tr[n], tr_u[n])
        usedtrs.append(numtrs[n])
        comms.append([numtrs[n], "c"])

    elif act == "ROLLBACK":
        tr[n] = None
        comms.append([numtrs[n], "r"])

    else:
        k, v = act.split('=')
        used[ord(k) - ord('A')] = True
        tr_u[n][ord(k) - ord('A')] = True



        if "+" in v:
            s1, s2 = v.split('+')

            ignore = [numtrs[n]]
            for j in range(len(comms) - 1, -1, -1):
                c = comms[j]
                if c[1] == 'c' or c[1] == 'r':
                    ignore.append(c[0])
                elif c[0] not in ignore and s1 in c[1]:
                    res.append([numtrs[n], c])


            if not tr_u[n][ord(s1) - ord("A")]:
                s1 = db[s1]
            else:
                s1 = tr[n][s1]
            v = int(s1) + int(s2)
        tr[n][k] = int(v)
        comms.append([numtrs[n], f'{k} {v}'])
        # print(n, tr[n])

# for k in db.keys():
#     if used[ord(k) - ord('A')]:
#         print(f"{k}={db[k]}")

ans = set()

for c in res:
    if c[0] in usedtrs:
        ans.add(tuple(c[1]))


ans = sorted(list(ans))
for k in ans:
    print(*k)

if len(ans) == 0:
    print("NO")

'''
1 BEGIN 5
1 A=5
2 BEGIN 7
1 B=1
2 B=A+10
1 COMMIT 5
2 COMMIT 7
.

5 B 1

---

1 BEGIN 1
2 BEGIN 2
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN 3
3 C=5
1 COMMIT 1
3 B=A+10
2 COMMIT 2
3 A=B+20
3 ROLLBACK 3
.

1 A 1
1 B 4

В продолжение к прошлой задаче требуется определить, значения каких ресурсов и в каких успешных транзакциях не были учтены в операциях, выполнявшихся позже них.

Входные данные: строки журнала выполнения транзакций, каждая в следующем формате:

N ACTION

где N - номер процесса от 1 до 99, ACTION - действие.

Возможные значения действия:

BEGIN M - начало транзакции;
COMMIT M - успешное завершение транзакции с сохранением всех значений;
ROLLBACK M - откат транзакции без сохранения изменений;
обновление.
M - целочисленный номер транзакции от 1 до 99. Каждая транзакция в журнале имеет уникальный номер.

Обновление ресурсов может иметь 2 записи: либо "x=K", либо "x=y+K" (без кавычек и пробелов), где x и y - обозначения ресурсов заглавной латинской буквой, а K - натуральное число от 1 до 99.

Начальные значения всех задействованных в программе ресурсов нулевые.

Журнал заканчивается строкой из одной точки.

Разные числа в начале строк обозначают разные процессы, разные буквы - разные ресурсы.

Гарантируется, что журнал не содержит противоречий, в том числе процесс не может начинать транзакцию, не завершив предыдущую, и к концу журнала все начатые транзакции будут завершены.

Выходные данные: номера транзакций, чьи зафиксированные изменения ресурсов не были учтены (были утрачены) в параллельно выполнявшихся транзакциях, по строкам в следующем формате: M x K, где M - номер транзакции, x - имя ресурса, K - конечное значение, установленное транзакцией, либо слово NO, если нет ни одного такого изменения.

Строки должны быть отсортированы по номерам транзакций, затем по именам ресурсов.

Дмитрий Александрович
18:39
"в обоих случаях выводится то, что изменялось параллельно в нескольких транзакциях"

Щагин Дмитрий Владимирович
18:45
В таком случае выходные данные второго теста должны быть 1 A 1, 2 B 2

Дмитрий Александрович
18:49
"Неправильные рассуждения"
'''